function toggle_thumbnail_with_preview_box(preview_box_element)
{
	if ( ! preview_box_element.className.match(/preview_box/) )
		return;
	var preview_img = preview_box_element.getElementsByClassName('preview')[0]
	if ( ! preview_img )
		return;
		
	//toggle the 'thumbnail' class and update image title
	if ( preview_box_element.className.match(/thumbnail/) ) {
		preview_box_element.className = 'preview_box'
		preview_img.setAttribute('title', "Click to minimize")
	}
	else {
		preview_box_element.className = 'preview_box thumbnail'
		preview_img.setAttribute('title', "Click to magnify")
	}
}

// onclick event from image attachments
function toggle_thumbnail(event)
{
	toggle_thumbnail_with_preview_box(event.target.parentNode)
}

function parent_attachment_box(node)
{
	if ( node == null )
		return null
		
	// parent attachment_box
	var attachment_box = event.target
	while ( attachment_box && (! attachment_box.className.match(/attachment_box/) ) )
		attachment_box = attachment_box.parentNode
	return attachment_box
	
	// child 'preview' img element
	if ( ! attachment_box.getElementsByClassName )
		return null
	if ( attachment_box.getElementsByClassName('preview').length < 1 )
		return null;
	return attachment_box.getElementsByClassName('preview')[0]
}

function did_dblclick_thumbnail(event)
{
	if ( ! bridge_is_available() )
		return;

	Bridge.didDoubleClickThumbnail(bridge_id_for_node(parent_attachment_box(event.target)))
}

function select_and_insert_attachment(event)
{
	if ( ! bridge_is_available() )
		return;

	// the bridge takes care of running an open panel to select an attachment file
	Bridge.selectAndInsertAttachment(bridge_id_for_node(parent_attachment_box(event.target)))
}

function did_dblclick_attachment_file(event)
{
	if ( ! bridge_is_available() )
		return;

	Bridge.didDoubleClickAttachmentFile(bridge_id_for_node(parent_attachment_box(event.target)))
}

function did_click_attachment_remove_button(event)
{
	if ( ! bridge_is_available() )
		return;

	Bridge.didClickAttachmentRemoveButton(bridge_id_for_node(event.target))
}

function did_click_attachment_zoom_button(event)
{
	toggle_thumbnail_with_preview_box(event.target.parentNode.parentNode)
}

function did_click_attachment_quicklook_button(event)
{
	if ( bridge_is_available() )
		Bridge.didClickAttachmentQuicklookButton(bridge_id_for_node(event.target))
}

function did_click_attachment_edit_button(event)
{
	if ( bridge_is_available() )
		Bridge.didClickAttachmentEditButton(bridge_id_for_node(event.target))
}

function did_click_attachment_open_button(event)
{
	if ( bridge_is_available() )
		Bridge.didClickAttachmentOpenButton(bridge_id_for_node(event.target))
}

function did_click_attachment_show_button(event)
{
	if ( bridge_is_available() )
		Bridge.didClickAttachmentShowButton(bridge_id_for_node(event.target))
}

function did_click_attachment_copy_button(event)
{
	if ( bridge_is_available() )
		Bridge.didClickAttachmentCopyButton(bridge_id_for_node(event.target))
}


/*  used to manipulate the drag image, but does not seem to work correctly for target that are already images - instead used css, much simpler! */
// see http://developer.apple.com/Mac/library/documentation/AppleApplications/Conceptual/SafariJSProgTopics/Tasks/DragAndDrop.html
// function did_start_drag_attachment_file(event)
// {
// 	dlog("starting here: " + event.target)
// 	dlog("parent: " + event.target.parentNode)
// 	dlog("parent parent: " + event.target.parentNode.parentNode)
// 	dlog("event: " + event)
// 	dlog("event.dataTransfer: " + event.dataTransfer)
// 	dlog("event.dataTransfer.setDragImage: " + event.dataTransfer.setDragImage)
// 	//event.preventDefault()
// 	event.dataTransfer.setDragImage(event.target.parentNode.parentNode,0.0,0.0)
// 	return true
// }
