function toggle_debug()
{
	// if already present, remove debug.css file
	var css_debug_ref = document.getElementById('css_debug')
	if ( css_debug_ref != null ) {
		document.getElementsByTagName("head")[0].removeChild(css_debug_ref)
		return;
	}
	
	var fileref=document.createElement("link")
	fileref.setAttribute("rel", "stylesheet")
	fileref.setAttribute("type", "text/css")
	fileref.setAttribute("href", "../../css/debug.css?"+Math.random())
	fileref.setAttribute("id", 'css_debug')
	document.getElementsByTagName("head")[0].appendChild(fileref)

}


/* Gutter Folding */

// onclick event from fold/unfold icon in the gutter
function toggle_folded(event)
{
	var gutter = event.target
	var paragraph = gutter.parentNode
	var container_header = paragraph.parentNode
	var container = container_header.parentNode
	var container_body = container_header.nextSibling
	while ( container_body  ) {
		if ( container_body.className  &&  container_body.className.match(/container_body/) )
			break
		else
			container_body = container_body.nextSibling
	}
	if ( ! container_body ) {
		//dlog('container_body is null! : ' + container_body )
		return
	}

	// only applicable for headers
	if ( ! paragraph.className.match(/(day|step|section)/) )
		return;
	
	// current state = folded --> change to unfolded
	if ( gutter.className.match(/folded/) ) {
		var gutter_class = gutter.className.replace('folded','')
		gutter_class = gutter_class.replace('  ',' ')
		var body_class = container_body.className.replace('folded','')
		body_class = body_class.replace('  ',' ')
		gutter.className = gutter_class
		container_body.className = body_class
	}

	// current state = unfolded --> change to folded
	else {
		gutter.className = gutter.className + ' folded'
		container_body.className = container_body.className + ' folded'
	}
}


function did_click_print_icon(event)
{
	var print_icon_div = event.target

	// only applicable for headers
	if ( ! print_icon_div.className.match(/container_print_icon/) )
		return;
	
	// current state = no_print --> change to print
	if ( print_icon_div.className.match(/no_print/) ) {
		var div_class = print_icon_div.className.replace('no_print','')
		div_class = div_class.replace('  ',' ')
		print_icon_div.className = div_class
	}

	// current state = print --> change to no_print
	else
		print_icon_div.className = print_icon_div.className + ' no_print'
}


/* Methods used to keep the proper selection orientation and supplement WebKit limited support in Cocoa */ 

// returns 1 if the current selection in the document is 'reverse', which means the 'base' is after the 'extent' position
// returns false otherwise, or if there is no selection defined
function selection_is_reverse()
{
	if ( !window || !document )
		return false;
	var selection = window.getSelection();
	if ( !selection )
		return false;
	if ( !selection.baseNode || !selection.extentNode  )
		return false;
	var baseRange = document.createRange();
	var extentRange = document.createRange();
	baseRange.setStart(selection.baseNode, selection.baseOffset);
	baseRange.collapse(true);
	extentRange.setStart(selection.extentNode, selection.extentOffset);
	extentRange.collapse(true);
	var START_TO_START = 0;
	if ( baseRange.compareBoundaryPoints(START_TO_START, extentRange) > 0 )
		return true;
	else
		return false;
}


// using Javascript to keep the correct orientation for the selection
// as suggested in http://lists.apple.com/archives/webkitsdk-dev/2007/Dec/msg00020.html
// "The _javascript_ Selection object returned by document.getSelection() supports baseNode(), baseOffset(), extentNode() and extentOffset().  You can use these to establish directionality and you can use setBaseAndExtent() to set a selection with the right directionality."
function swap_selection_base_and_extent()
{
	//	debug("1");
	if ( !window || !document )
		return false;
	var selection = window.getSelection();
	if ( !selection )
		return false;

	//debug(get_properties(selection));
	var baseNode = selection.baseNode;
	var baseOffset = selection.baseOffset;
	var extentNode = selection.extentNode;
	var extentOffset = selection.extentOffset;
	if ( !selection.baseNode || !selection.extentNode  )
		return false;
	
	//	debug("2");
	// this seems to be necessary before setting the base and extent, otherwise it does not overwrite the current values for the selection
	selection.removeAllRanges();
	selection.setBaseAndExtent(extentNode, extentOffset, baseNode, baseOffset);
}
