var timestamp_patterns = [
// regex defines some captures  -->  results tells which capture index to use
{ 'regex': /(\d\d):(\d\d):(\d\d)/              ,  'results':[   0  ,   1   ,   2   ] },
{ 'regex': /(\d\d?)\s*h\s*(\d\d?)\s*min/       ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /(\d\d?)\s*h\s*(\d\d?)\s*m\s/       ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /(\d\d?)\s*hours?\s*(\d\d?)\s*min/  ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /(\d\d?)\s*hours?\s*(\d\d?)\s*m\s/  ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /(\d\d?)\s*hrs?\s*(\d\d?)\s*min/    ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /(\d\d?)\s*hrs?\s*(\d\d?)\s*m\s/    ,  'results':[   0  ,   1   , null  ] },
{ 'regex': /\s(\d\d?):(\d\d)\s/                ,  'results':[ null ,   0   ,   1   ] },
{ 'regex': /\s(\d\d?)'\s*(\d\d?)"?\s/          ,  'results':[ null ,   0   ,   1   ] },
{ 'regex': /(\d+)\s*hours?\s/                  ,  'results':[   0  , null  ,  null ] },
{ 'regex': /(\d+)\s*hrs?\s/                    ,  'results':[   0  , null  ,  null ] },
{ 'regex': /(\d+)\s*h\s/                       ,  'results':[   0  , null  ,  null ] },
{ 'regex': /(\d+)\s*minutes?/                  ,  'results':[ null ,   0   ,  null ] },
{ 'regex': /(\d+)\s*mins?/                     ,  'results':[ null ,   0   ,  null ] },
{ 'regex': /(\d+)\s*m\s/                       ,  'results':[ null ,   0   ,  null ] },
{ 'regex': /(\d+)\s*'\s/                       ,  'results':[ null ,   0   ,  null ] },
{ 'regex': /(\d+)\s*secs?\s/                   ,  'results':[ null ,  null ,   0   ] },
{ 'regex': /(\d+)\s*s\s/                       ,  'results':[ null ,  null ,   0   ] },
{ 'regex': /(\d+)\s*"\s/                       ,  'results':[ null ,  null ,   0   ] },
]

function search_string_with_patterns(astring, pattern_array)
{
	var max = pattern_array.length
	astring = ' ' + astring + ' '
	astring.replace(',',' , ')
	astring.replace('\(',' ( ')
	astring.replace('\)',' ) ')
	for ( var i = 0 ; i < max ; i++ ){
		// // eval runs the function specified in patterns with parameter s = astring
		// // ---> eval('try { (function(s){ return s })(astring)') } catch { null }')
		// var eval_string = 'try { (function(s) { return ' + pattern_array[i] + ' } )(astring) } catch(err){ }'
		// // eval_string = 'try { dlog("hello")} catch(err){}'
		// // dlog(eval_string)
		// var matches = eval(eval_string)
		
		var matches = astring.match(pattern_array[i]['regex'])
		var components = [undefined, undefined, undefined]
		if ( matches && matches.length && ( matches.length > 1 ) ) {
			// remove the match, only keep the captures
			matches.shift()
			var results = pattern_array[i]['results']
			for ( var k in [0,1,2] ) {
				if ( results[k] >=0 && results[k] < matches.length && results[k] != null )
					components[k] = matches[results[k]]
			}
		}

		var ts = new TimeStamp(components[0], components[1], components[2])
		// dlog('Components for pattern = ' + pattern_array[i]['regex'])
		// dlog('...components = ' + components[0] + ' , ' + components[1] + ' , ' + components[2])
		// dlog('...timestamp = ' + ts.timeString())
		if ( ts.isDefined() )
			return ts
	}
	return new TimeStamp(undefined)
}


function timestamp_from_text(astring)
{
	return search_string_with_patterns(astring, timestamp_patterns)
}


// tests
function patterns_run_tests() {
	if ( ! document.body )
		setTimeout(patterns_run_tests, 500)
	var tests = [
		{ 'input':'incubate 5 h 45 min'   , 'output':'05:45:00' },
		{ 'input':'incubate 5h45m'        , 'output':'05:45:00' },
		{ 'input':'incubate 5h 45m'       , 'output':'05:45:00' },
		{ 'input':'incubate 5hr 45m'      , 'output':'05:45:00' },
		{ 'input':'incubate 5hrs 45mins'  , 'output':'05:45:00' },
		{ 'input':'incubate 13hrs'        , 'output':'13:00:00' },
		{ 'input':'incubate 13hr'         , 'output':'13:00:00' },
		{ 'input':'incubate 13h'          , 'output':'13:00:00' },
		{ 'input':'incubate 13 hrs'       , 'output':'13:00:00' },
		{ 'input':'incubate 13 hr'        , 'output':'13:00:00' },
		{ 'input':'incubate 13 h'         , 'output':'13:00:00' },
		{ 'input':'incubate 05:10'        , 'output':'00:05:10' },
		{ 'input':'incubate 5:10'         , 'output':'00:05:10' },
		{ 'input':'incubate 5\'10'        , 'output':'00:05:10' },
		{ 'input':'incubate 5\'10"'       , 'output':'00:05:10' },
		{ 'input':'incubate 5\' 10'       , 'output':'00:05:10' },
		{ 'input':'incubate 5\' 10"'      , 'output':'00:05:10' },
		{ 'input':'incubate for 30secs'   , 'output':'00:00:30' },
		{ 'input':'incubate for 30sec'    , 'output':'00:00:30' },
		{ 'input':'incubate for 30 s'     , 'output':'00:00:30' },
		{ 'input':'incubate for 30s'      , 'output':'00:00:30' },
		{ 'input':'incubate for 30 "'     , 'output':'00:00:30' },
		{ 'input':'incubate for 30"'      , 'output':'00:00:30' },
		{ 'input':'incubate for 7min'     , 'output':'00:07:00' },
		{ 'input':'incubate for 7mins'    , 'output':'00:07:00' },
		{ 'input':'incubate for 7 min'    , 'output':'00:07:00' },
		{ 'input':'incubate for 7 mins'   , 'output':'00:07:00' },
		{ 'input':'dry 7 mins, and store' , 'output':'00:07:00' },
		{ 'input':'centrifuge (7 min)'    , 'output':'00:07:00' },
		{ 'input':'incubate for 7\''      , 'output':'00:07:00' },
		{ 'input':'incubate for 7 \''     , 'output':'00:07:00' },
	]
	var tests_max_count = tests.length
	var success = true
	for ( var test_index = 0 ; test_index < tests_max_count ; test_index++ ) {
		var input = tests[test_index]['input']
		var expected_output = tests[test_index]['output']
		var actual_output = timestamp_from_text(input).timeString()
		if ( expected_output != actual_output ) {
			dlog('Failed test with:')
			dlog('...input     = ' + input)
			dlog('...output    = ' + actual_output)
			dlog('...expected  = ' + expected_output)
			success = false
		}
	}
	// if ( success )
	// 	dlog('All tests passed')
}

setTimeout(patterns_run_tests, 500)
